﻿/*
 * Program: spingdar   
 * Author:  Jeffrey H. Albrecht aka jeffa
 * email:	jeffa@iea-software.com
 * Date:	April 4, 2010
 * 
 * license: I don't know why you would want to use it but go ahead.
 * if you make money with it I want some of the money!
 *              
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace SpingDar
{
    public partial class SpingDar : Form
    {
        Pen penBlack = new Pen(Color.Black, 2);
        Pen penGreen = new Pen(Color.Green, 1);
        Pen penWhite = new Pen(Color.White, 4);
        Pen penYellow = new Pen(Color.Yellow, 1);
        Font font = new Font("Arial", 40);
        float fudge;
        //DateTime oldDateTime;

        public SpingDar()
        {
            InitializeComponent();
        }
        SerialPort port = new SerialPort();
        void port_DataReceived(object sender, SerialDataReceivedEventArgs e)
        //protected override void OnPaint(PaintEventArgs e)
        {
            // fudge factor to reduce size of SpingDarScope because width and height are retured to exterior of form
            fudge = 100f;
            //Graphics g = e.Graphics;
            Graphics rs = this.CreateGraphics();
            SetScale(rs);            // set the origin 0,0 to the middle of the form
            // make a set of points for the 'from'
            PointF pntOrigin = new PointF(-(Width - fudge) / 2, -(Height - fudge) / 2);
            // make a set of size of the radar scope
            SizeF szeRadarScope = new SizeF(Width - fudge, Height - fudge);
            // create a rectangle representing the outer bounds of the radar scope
            RectangleF rctRadarScope = new RectangleF(pntOrigin, szeRadarScope);
            rs.FillEllipse(Brushes.Black, rctRadarScope);    // Paint radar scope
            // put some grid lines on the scope
            rs.DrawLine(penGreen, 0, -((.5f * Width) - (.5f * fudge)), 0, ((.5f * Width) - (.5f * fudge)));     // paint x gridline
            rs.DrawLine(penGreen, -((.5f * Height) - (.5f * fudge)), 0, (.5f * Height) - (.5f * fudge), 0);    // paint y gridline
            rs.FillEllipse(Brushes.Green, -10, -10, 20, 20); // paint center dot
            // draw some range circles on the scope
            // TODO modify to support screen resizing
            rs.DrawEllipse(penGreen, -100, -100, 200, 200);
            rs.DrawEllipse(penGreen, -200, -200, 400, 400);
            rs.DrawEllipse(penGreen, -300, -300, 600, 600);
            // display the four quadrants in world notation
            float ix = (.5f * Width) - 200;
            float iy = (.5f * Height) - 200;
            rs.DrawString("-x, -y", Font, Brushes.White, -ix, -iy);
            rs.DrawString("x, -y", Font, Brushes.White, ix, -iy);
            rs.DrawString("x, y", Font, Brushes.White, ix, iy);
            rs.DrawString("-x, y", Font, Brushes.White, -ix, iy);

            // read and parse the data from the xbee radio. Sample line: R1238A1195
            string data = port.ReadLine();

            //string data = "R1238A500"; // 0 degree angle
            //string data = "R1238A1500"; // 90 degree angle
            //string data = "R1238A2500"; // 180 degree angle
            //string data = "R1238A1000"; // 45 degree angle
            int ap = data.IndexOf("A", 0);  // find postion of 'P' pp = p position
            string angleData = data.Substring(ap + 1);
            string rangeData = data.Substring(1, ap - 1);   // strip preceding 'R'
            float ty = float.Parse(rangeData);
            
            float tx = float.Parse(angleData);
            float pingangle = ofMap(tx, 500, 2500, 0, 180);
            // TODO definitivley research maximum ping distance returned by ping object
            float y = ofMap(ty, 1, 2000, 0, (float).5m * this.ClientRectangle.Height);
            float x = ofMap(tx, 500, 2500, (float)this.ClientRectangle.Height, 0);
            // rs.DrawEllipse(whitePen, (float).5m * this.ClientRectangle.Width, (int)y, 1, 1);
            // rs.DrawEllipse(penWhite, x, (int)y, 1, 1);

            // Return CSng(Math.Cos((Math.PI * degAngle / 180.0F)))
            int deg = 180;
            int pingDistance = 325;
            deg = (int)pingangle;
            pingDistance = (int)y;


            //deg = int.Parse(angleData);
            //pingDistance = int.Parse(rangeData);


            //double x = Math.Cos(d) * 200;
            //double y = Math.Sin(d) * 200;

            float xx = GetCos(deg + 180) * pingDistance;
            float yy = GetSin(deg + 180) * pingDistance;

            //float xx = GetCos(tx + 180) * ty;
            //float yy = GetSin(tx + 180) * ty;

            rs.DrawLine(penYellow, 0, 0, (int)xx, (int)yy);
            //rs.DrawLine(Pens.Red, 0, 0, (int)x, (int)y);
            rs.DrawEllipse(penWhite, xx, yy, 1, 1);

            //base.OnPaint(rs);
            //Invalidate();

        }

        private static float GetSin(float degAngle)
        {
            return (float)Math.Sin(Math.PI * degAngle / 180f);
        }

        private static float GetCos(float degAngle)
        {
            return (float)Math.Cos(Math.PI * degAngle / 180f);
        }
        private void SetScale(Graphics g)
        {
            // if the form is too small, do nothing
            if (Width == 0 || Height == 0)
                return;
            // set the origin at the center
            g.TranslateTransform(Width / 2, Height / 2);
            // set inches to the minimum of the width
            // or height dividedby the dots per inch
            //float inches = Math.Min(Width / g.DpiX, Height / g.DpiX);
            // set the scale to a grid of 2000 by 2000 units
            //g.ScaleTransform(inches * g.DpiX / 200, inches * g.DpiY / 200);
        }

        // grabed this from openframeworks.cc Note: openframeworks is cool!
        float ofMap(float value, float inputMin, float inputMax, float outputMin, float outputMax)
        {
            return ((value - inputMin) / (inputMax - inputMin) * (outputMax - outputMin) + outputMin);
        }

        private void commSetup()
        {
            // setup the serial port
            port = new System.IO.Ports.SerialPort("COM12");
            port.Parity = Parity.None;
            port.BaudRate = 9600;
            port.StopBits = StopBits.Two;
            port.DataBits = 8;
            port.NewLine = "\r"; // \n is default
            port.DataReceived += new SerialDataReceivedEventHandler(port_DataReceived);
            port.Open();
        }

        private void btnDelegate_Click(object sender, EventArgs e)
        {
            MessageBox.Show("huh?");
        }

        private void SpingDar_Load(object sender, EventArgs e)
        {
            commSetup();
        }
    }
}
